//Michael Good, 4/2/2012
//Chat Program - Sends and recieves messages from a server over the network/internet

import java.awt.*;
import java.applet.*;
import java.net.*;
import javax.swing.*;
import java.awt.event.*;
import java.io.*;

public class ChatClient extends JApplet
{
	protected TextArea output;
	protected TextField username;
	protected TextField input;
	protected final String newLine = System.getProperty("line.separator");
	
	protected PrintWriter out;
	protected Socket host;

	//Start program
	public void init()
	{
		setSize(300, 600);
		
		setLayout (new BorderLayout());
		
		output = new TextArea();
		output.setEditable(false);
		
		add(output, BorderLayout.CENTER);
		add(input(), BorderLayout.SOUTH);
		
		Connection chat = new Connection();
		Thread chatProcess = new Thread(chat);
		chatProcess.start();
	}
	
	//Setup input panel
	private Panel input()
	{
		Panel me = new Panel();
		
		input = new TextField();
		username = new TextField();
		
		username.setColumns(10);
		input.addActionListener(new textMessage());
		
		me.setLayout (new BorderLayout());
		me.add(input, BorderLayout.CENTER);
		me.add(username, BorderLayout.WEST);
		
		return me;
	}
	
	//Handles the 'enter' event from the textbox; send texts to server
	private class textMessage implements ActionListener
	{
		public void actionPerformed (ActionEvent e)
		{
			out.println(username.getText() + ": " + input.getText());
			input.setText("");
		}
	}
	
	//Handles connection with server
	private class Connection implements Runnable
	{
		protected BufferedReader in;
		protected Socket host;
		protected String fromHost;
		
		//Setup connection
		public Connection()
		{
			try
			{
				InetAddress hostPlace = InetAddress.getByName("mjgood91-chat.servehttp.com");
				host = new Socket(hostPlace, 7005);
				out = new PrintWriter(host.getOutputStream(), true);
				in = new BufferedReader(new InputStreamReader(host.getInputStream()));
			}
			catch (IOException e)
			{
				output.setText("ERROR: initialization I/O error!" + newLine);
			}
		}
		
		//Get texts from server
		public void run()
		{
			boolean notified = false;
		
			while (true)
			{
				try
				{
					fromHost = in.readLine();
					if (fromHost != "")
					{
						output.append(fromHost + newLine);
					}
				}
				catch (IOException e)
				{
					output.append("ERROR: get data I/O error!" + newLine);
				}
				catch (NullPointerException e)
				{
					if (!notified)
					{
						output.append("ERROR: bad connection!" + newLine);
						notified = true;
					}
				}
			}
		}
	}
}